%#########################################################################
%out_uv size is  2 x n_triangles
%out_model is zise 3x n_triangles
%tran and angles are 3x1
%init_object_pos=['xmode';'ymode';'zmode'], each mode for x can be xmin,xmax,xmid etc.
function [out_uv, out_model]=read_model(scale,aspect,init_object_pos,...
    raw_w, flen , init_angles, init_trans, angles, trans,... 
    ixcenter,iycenter,theta,rotate_normal,target_vector3 ,rt,frame_t,RT_solutions)

load ba_inpar.mat
zinit=in.z_init_meters/in.pixel_width_meters

clear rotate_normal


[ntri,foo]=size(raw_w);

display=0;

%scale=276; %sacle up each face is about 150mm=0.15m=0.15/(5.42^-6)=27675 pixelwide,
%orginal model is 100 pixel wide, so scale is 27675/100=276
%scale=150; %fror a samller model face           

%raw_allw=scale*[raw_w(:,1:3); raw_w(:,4:6); raw_w(:,7:9)]'; %first row is x, second row is y, third is z; 3 columes form a triangle
for i=1:ntri
    temp(1+i*3:3+i*3,:)=scale*[raw_w(i,1:3); raw_w(i,4:6); raw_w(i,7:9)]; %first row is x, second row is y, third is z; 3 columes form a triangle
end

raw_allw=temp';
raw_allw(1,:)=raw_allw(1,:)*aspect;


[foo,n_raw_allw]=size(raw_allw);  %first row is x, second row is y, third is z; 3 columes form a triangle

%----------------------------------- shift model to init position. ----
object_mid=mean(raw_allw,2); %3x1 for middle of object

object_min_x=min(raw_allw(1,:)); %3x1 for middle of object
object_max_x=max(raw_allw(1,:)); %3x1 for middle of object
object_mid_x=(object_min_x+object_max_x)/2;

object_min_y=min(raw_allw(2,:)); %3x1 for middle of object
object_max_y=max(raw_allw(2,:)); %3x1 for middle of object
object_mid_y=(object_min_y+object_max_y)/2;

object_min_z=min(raw_allw(3,:)); %3x1 for middle of object
object_max_z=max(raw_allw(3,:)); %3x1 for middle of object
object_mid_z=(object_min_z+object_max_z)/2;

%---- xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx ----------------------------------
disp('test61')
init_object_pos(1,:)
if init_object_pos(1,:) =='xmin'
    allw(1,:)=raw_allw(1,:) - object_min_x;
elseif init_object_pos(1,:) =='xmid'
    allw(1,:)=raw_allw(1,:) - object_mid_x;
else init_object_pos(1,:) =='xmax'
    allw(1,:)=raw_allw(1,:) - object_max_x;
end

%---- yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy ----------------------------------
if init_object_pos(2,:) =='ymin'
    allw(2,:)=raw_allw(2,:) - object_min_y;
elseif init_object_pos(2,:) =='ymid'
    allw(2,:)=raw_allw(2,:) - object_mid_y;
else init_object_pos(2,:) =='ymax'
    allw(2,:)=raw_allw(2,:) - object_max_y;
end
%---- zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz ----------------------------------
if init_object_pos(3,:) =='zmin'
    allw(3,:)=raw_allw(3,:) - object_min_z;
elseif init_object_pos(3,:) =='zmid'
    allw(3,:)=raw_allw(3,:) - object_mid_z;
else init_object_pos(3,:) =='zmax'
    allw(3,:)=raw_allw(3,:) - object_max_z;
end
[foo,n_allw]=size(allw);  %first row is x, second row is y, third is z; 3 columes form a triangle
% mean_allw=mean(allw,2)
% centered_allw(1,:)=allw(1,:);%-mean_allw(1,:);
% centered_allw(2,:)=allw(2,:);%-mean_allw(2,:);
% centered_allw(3,:)=allw(3,:); % no chnage



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  TO put virtual object into pictures
%
%%% new %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%step1 ----- aglign virtual wireframe object with target_vector3 -------- 
%align object with v3 first, v3=centered normal of the target triangle
v3=(target_vector3(:,1)-target_vector3(:,2))/norm(target_vector3(:,1)-target_vector3(:,2))'
vr3=cross(v3,[ 0 1 0]') %rotational axis
theta_vr3=acos(dot(v3,[ 0 1 0]'))
R3=axis_angle2R(theta_vr3,vr3)
allw3= R3*allw; %allw3 is centered at target_vectro3(:,1)

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %step 2 ----- rotate virtual object with synchnroy with real object 
% %transform rt using zinit as center -----
% if frame_t==1
%     T_rt=[0 0 zinit]'
%     R_rt=eye(3)
% else
%     R_rt=rt(1:3,1:3,frame_t-1)
%     T_rt=rt(1:3,4,frame_t-1)
% end    
% t3=target_vector3(:,1)- T_rt
% allw5 = inv(R_rt)'  *   (allw3+repmat(t3,1,n_allw))  ;
% out_allw = allw5 + repmat(T_rt,1,n_allw);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%step 2 ----- rotate virtual object with synchnroy with real object 
%transform rt using zinit as center -----
if frame_t==1
    T_rt=[0 0 zinit]'
    R_rt=eye(3)
else
    R_rt=rt(1:3,1:3,frame_t-1)
    T_rt=rt(1:3,4,frame_t-1)
end    
t3=init_trans
%t3=target_vector3(:,1)- T_rt
%t3=target_vector3(:,1)

allw5 = inv(R_rt)'  *   (allw3+repmat(t3,1,n_allw))  ;

out_allw = allw5 + repmat(T_rt,1,n_allw);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%------------- out generated ---------------
%number of trianlges=size(rt_allw)/3
size(out_allw);

x=out_allw(1,:);
y=out_allw(2,:);
z=out_allw(3,:);
%w_center=[mean(x),mean(y),mean(z)]; %???????????????????????????????????
out_model=[x;y;z];
%-----------------------
u_out_allw = ixcenter + (flen*x./(z));
v_out_allw = iycenter + (flen*y./(z));
out_uv=[u_out_allw;v_out_allw]; %2 x ntri

if display==1
    %1111111111111111111111111111111111111111111111111
    figure(1)
    clf
    hold on
    
    [foo,nn]=size(x);
    ntri=nn/3
    
    for i=1:ntri
        j=i-1;
        %   plot(uu(1,1+j*3:3+j*3),vv(1,1+j*3:3+j*3),'r-');   
        %join poin1 to 2 , 2  to 3, 3 to 1
        xx=[x(1,1+j*3:3+j*3),x(1,1+j*3)];
        yy=[y(1,1+j*3:3+j*3),y(1,1+j*3)];
        zz=[z(1,1+j*3:3+j*3),z(1,1+j*3)];
        line(xx,yy,zz);
    end
    title('3d wireframe')   
    
    %	plot3(x,y,z,'r.'); %draw triangles
    %	line(x,y,z); %draw triangles
%    plot3(w_center(1),w_center(2),w_center(3),'b+');
    plot3(0, 0, 0 ,'r+');
    
    xlabel('x-axis');
    ylabel('y-axis');
    zlabel('z-axis');
    
    rotate3d on;
    
    %22222222222222222222222222222222222222222222222222222222
    uu=u_out_allw;
    vv=v_out_allw;
    [foo,nn]=size(uu);
    ntri=nn/3
    
    figure(2)
    clf
    hold on
    for i=1:ntri
        j=i-1;
        %   plot(uu(1,1+j*3:3+j*3),vv(1,1+j*3:3+j*3),'r-');   
        %join poin1 to 2 , 2  to 3, 3 to 1
        
        u=[uu(1,1+j*3:3+j*3),uu(1,1+j*3)];
        v=[vv(1,1+j*3:3+j*3),vv(1,1+j*3)];
        line(u,v);
    end
    title('2d wireframe')
    %	disp('test2');
    
end
return
