%inpuit parameters, default outfile is same as this filename with.mat extension
%outfile: is klt_data
%
function in=inpara1(klt_stage,klt_display_tag,tname)

in.klt_stage=klt_stage;
in.klt_display_tag=klt_display_tag;


%--static parameters -----------------
%set drive (c:,d:,etc) in klt_00_init.m
in.test_mode='real_images'; 
%in.test_method='; 
%in.from_stage=from_stage
%in.show_feature_mode=show_feature_mode;
%in.klt_data_fname='klt_data';

%%%%%%%%%% temporary added information 
in.nF_step=1

%????????????
switch tname
        case 'head11a'
        in.tname='head11a';
        in.extension='.bmp';
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=90; %number of avaible frame in the sequence.
        in.n_sector_frames=80; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=100; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 520 10 440]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.0005 100 0.0005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
   case 'head11b'
        in.tname='head11b';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=90; %number of avaible frame in the sequence.
        in.n_sector_frames=80; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=100; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 520 10 440]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.0005 100 0.0005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'cam112_1'
        in.tname='cam112_1';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=70; %number of avaible frame in the sequence.
        in.n_sector_frames=60; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
   case 'cam112_2'
        in.tname='cam112_2';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=70; %number of avaible frame in the sequence.
        in.n_sector_frames=60; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'cam113_1_sing'
        in.tname='cam113_1';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=110; %number of avaible frame in the sequence.
        in.n_sector_frames=105; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
    case 'cam113_1'
        in.tname='cam113_1';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=110; %number of avaible frame in the sequence.
        in.n_sector_frames=105; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
   case 'cam113_2_sing'
        in.tname='cam113_2';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=30; %number of avaible frame in the sequence.
        in.n_sector_frames=25; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
  case 'cam113_2'
        in.tname='cam113_2';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=110; %number of avaible frame in the sequence.
        in.n_sector_frames=105; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
   %in.klt_check_xy_limit_tag=1;in.features_xy_limits=[220 500 100 340]; %[xmin xmax, ymin ymax]
   in.klt_check_xy_limit_tag=1;in.features_xy_limits=[20 620 10 460]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        

    case 'corn5'
        in.tname='corn5';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=29; %number of avaible frame in the sequence.
        in.n_sector_frames=10; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[100 500 100 420]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.5 100 0.5 100]; 
        in.mismatch_filter_tag=1;
        in.threshold_epip_error=0.3; %in pixels
%        in.nF_step=1;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    
    case 'ck1a'
        in.tname='ck1a';
        in.extension='.jpg';

        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=29; %number of  frame in the sequence.
        in.n_sector_frames=20; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 300 10 220]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=1; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
    case 'ck1b'
        in.tname='ck1b';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=25; %number of avaible frame in the sequence.
        in.n_sector_frames=20; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 300 10 220]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.005 100 0.005 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=1; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'cany525'
        in.tname='cany525';
        in.extension='.bmp';
    
        in.workmode='lowe';
        in.klt_replace_tag=1;
        in.total_frames_in_sequence=80; %number of avaible frame in the sequence.
        in.n_sector_frames=100; %74
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[50 700 20 500]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.01 5 0.01 5]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=2;%0.3; %in pixels
    
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
    case 'lab524'
        in.tname='lab524';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=1;
        in.total_frames_in_sequence=40; %number of avaible frame in the sequence.
        in.n_sector_frames=43; %74
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[30 700 20 440]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=0;in.features_motion_limits=[0.01 5 0.01 5]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=2; %0.3 in pixels

        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'siu1a'
        in.tname='siu1a';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=8; %number of avaible frame in the sequence.
        in.n_sector_frames=8; %292 %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=[ 1]
        in.n_features=1000; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[50 600 50 450]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.5 20 0.5 20]; 
        
        in.mismatch_filter_tag=0;
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        in.threshold_epip_error=7; %0.3; %in pixels
        
    case 'robot216'
        in.tname='robot216';
        in.extension='.jpg';
        in.workmode='lowe';
        in.klt_replace_tag=1;
        in.total_frames_in_sequence=293; %number of avaible frame in the sequence.
        in.n_sector_frames=15 %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=[ 1 ];
        in.n_features=1000; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[250 900 180 680]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.05 100 0.05 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'boxe3'
        in.tname='boxe3';
        in.extension='.bmp';
    
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=239; %number of avaible frame in the sequence.
        in.n_sector_frames=20; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %239-70=169 total 293 images
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[80 600 50 450]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.5 100 0.5 100]; 
        in.mismatch_filter_tag=0;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        in.threshold_epip_error=0.3; %in pixels
        
        %hardcode for boxe3_one , will change to ginput hand-click later
        switch in.n_sector_frames
            case 10,
                in.lock_points=[283 225 287 ]% found by display ixy numbers, anti clockwise order, middle point is loc., for augmented_relaity for 10 frames
            case 20
                in.lock_points=[281 223 225 ]% found by display ixy numbers, anti clockwise order, middle point is loc., for augmented_relaity for 10 frames
            otherwise
                'wrong n_sector_frame for lock point setting,  input see inpar.m '
        end

        
    case 'arcaba'
        in.tname='arcaba';
        in.extension='.jpg';
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=19; %number of avaible frame in the sequence.
        in.n_sector_frames=10; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %239-70=169 total 293 images
        in.n_features=500; %500
        in.markersize_features=3;
        in.z_init_meters=33; %0.33
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 700 100 250 ]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.5 100 -0.5 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels

        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'canyon1'
        in.tname='canyon1';
        in.extension='.jpg';
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=15; %number of avaible frame in the sequence.
        in.n_sector_frames=14; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %239-70=169 total 293 images
        in.n_features=1000; %500
        in.markersize_features=3;
        in.z_init_meters=3.3; %0.33
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 600 15 400 ]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.5 100 -0.5 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'piantist'
        in.tname='piantist';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=43; %number of avaible frame in the sequence.
        in.n_sector_frames=30; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        
        in.base_frame_index=1;; %239-70=169 total 293 images
        in.n_features=1000; %500
        in.markersize_features=3;
        in.z_init_meters=3.3; %0.33
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[100 500 10 300 ]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.5 100 -0.5 100]; 
        in.mismatch_filter_tag=0;
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=1; %0 for lowe, 0 for cir, 
        in.threshold_epip_error=0.3; %in pixels
        
    case 'robot3'
        in.tname='robot3';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=14; %number of avaible frame in the sequence.
        in.n_sector_frames=14; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[100 550 20 420]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.05 100 0.05 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'house01'
        in.tname='house01';
        in.extension='.jpg';
        
        in.workmode='lowe';
        in.klt_replace_tag=1;
        in.total_frames_in_sequence=29; %number of avaible frame in the sequence.
        in.n_sector_frames=15; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[200 800 80 680]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.1 5 0.1 5]; 
        in.mismatch_filter_tag=0;

        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        in.threshold_epip_error=2; %0.3; %in pixels
        
    case 'robot2'
        in.tname='robot2';
        in.extension='.bmp';

        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=15; %number of avaible frame in the sequence.
        in.n_sector_frames=15; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[150 550 50 400]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.1 50 0.1 50]; 
        in.mismatch_filter_tag=0;
         in.threshold_epip_error=0.3; %in pixels
       
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'labe7'
        in.tname='labe7';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=100; %number of avaible frame in the sequence.
        in.n_sector_frames=20; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=800; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 630 10 470]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.5 50 0.5 50]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'labe1'
        in.tname='labe1';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=29; %number of avaible frame in the sequence.
        in.n_sector_frames=10; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=1000; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 630 10 470]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.1 50 0.1 50]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    case 'flask7'
        in.tname='flask7';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=29; %number of avaible frame in the sequence.
        in.n_sector_frames=20; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=300; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
        in.klt_check_xy_limit_tag=1;in.features_xy_limits=[250 420 40 440]; %[xmin xmax, ymin ymax]
        in.klt_feature_motion_tag=1;in.features_motion_limits=[0.05 100 0.05 100]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
    case 'shake2'
        in.tname='shake2';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=1;
        in.total_frames_in_sequence=150; %number of avaible frame in the sequence.
        in.n_sector_frames=30; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=330; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
         in.klt_check_xy_limit_tag=1;in.features_xy_limits=[1 319 1 239]; %[xmin xmax, ymin ymax]
       in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.05 50 -0.05 50]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
 case 'shake4'
        in.tname='shake4';
        in.extension='.bmp';
        
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=70; %number of avaible frame in the sequence.
        in.n_sector_frames=69; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=200; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
         in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 630/2 10 460/2]; %[xmin xmax, ymin ymax]
       in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.005 50 -0.005 50]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
 case 'video17'
        in.tname='video17';
        in.extension='.bmp';
        in.workmode='lowe';
        in.klt_replace_tag=0;
        in.total_frames_in_sequence=70; %number of avaible frame in the sequence.
        in.n_sector_frames=50; %100 %239-10-1; %73
        in.Tinit=in.n_sector_frames-1;
        in.base_frame_index=1;; %[ 1 1 1 1] %dummy for gc_gen_vrml (even for one sector)
        in.n_features=200; %500
        in.markersize_features=3;
        in.z_init_meters=0.33;
        in.pixel_width_meters=5.42*10^-6;
         in.klt_check_xy_limit_tag=1;in.features_xy_limits=[10 630/2 10 460/2]; %[xmin xmax, ymin ymax]
       in.klt_feature_motion_tag=1;in.features_motion_limits=[-0.1 50 -0.1 50]; 
        in.mismatch_filter_tag=0;
        in.threshold_epip_error=0.3; %in pixels
        
        in.vrml.extension=in.extension
        in.vrml.write_mode= 'one' ;%'omni' : all angles (combined by 4), 'independent'= 4 different views ,'one'
        in.vrml.external_internal_texture_mode=0; %1 or 0 %0 for lowe
        in.vrml.inside_out_transform=0; %0 for lowe, 0 for cir, 
        
    otherwise
        'wrong case in ba'
end

