%reads nframes from first_index of an avi file and save as pictures, 
%otput file index starts from 000, ends nframes-1
%extension to be specified by user. bmp, pgm etc
function avi2img(avi_filename,out_dir,out_head,first_index,nframes,extension)    
% first_index=
% nframes=10
% out_dir='d:\\11temp\\'

% filename='video17.avi'
 avi_info=aviinfo(avi_filename);
 mov=aviread(avi_filename);

for (n=first_index:first_index+nframes-1)
    [im,Map] = frame2im(mov(n)); %mov starts from 1, img_index starts from 000
    out_filename=strcat(out_dir,out_head,num2str_lead0(n-1,3),extension);%img_index starts from 000
    imwrite(im,out_filename,extension(2:4)); %dot of extnesion is not used
end
