% function used to check the direction of the normal of triangle and change to the correct direction %

function TRI = ct_test_tri_dir(TRI,tri_iix,tri_iiy,vrml_external_internal_texture_mode)

N = size(TRI,1);

% form the vectors from the elements in "TRI" %

for i = 1:N,
   V1 = [tri_iix(1,TRI(i,2))-tri_iix(1,TRI(i,1)),tri_iiy(1,TRI(i,2))-tri_iiy(1,TRI(i,1)),0]; 
   V2 = [tri_iix(1,TRI(i,3))-tri_iix(1,TRI(i,2)),tri_iiy(1,TRI(i,3))-tri_iiy(1,TRI(i,2)),0]; 
   
   % cross product of the two vectos %
   
   V3 = cross(V1,V2);
   
   % test the direction of the normal formed %    
   switch vrml_external_internal_texture_mode
   case 0 %normal texture on external
      if V3(1,3) > 0
         swap = TRI(i,2);
         TRI(i,2) = TRI(i,3);
         TRI(i,3) = swap;
      end
   case 1 %reverse textrue mapping , on internal
      if V3(1,3) < 0
         swap = TRI(i,2);
         TRI(i,2) = TRI(i,3);
         TRI(i,3) = swap;
      end
   case default
      disp('unknown reverse mode in ct_fix_tri_dir2.m '),pause
   end
end

return
