function klt(klt_outfile,cam,wdir,feature,in)

%111111copy image files to pgm files and extract raw features 1111111111111111111111111111111111
if in.klt_stage <= 1 %feature extraction
    in.base_frame=in.base_frame_index;
    in.n_frames=in.n_sector_frames; %293
    
    %------ call main program --------------------------------------------
    for n=in.base_frame:in.n_frames
        wdir.test_file_list(n,:)=strcat(wdir.test_dir_name,wdir.test_name,'_',num2str_lead0(n-1,3),in.extension);
    end
    [feature,dos_return]=cv_klt_10_extract_raw_features(in,cam,wdir,feature); %it is new from ct33a
    %   end
end
%222 feature filtering   222222222222222222222222222222222222222222222
if in.klt_stage <=2 %feature filtering
    in.base_frame=in.base_frame_index;
    in.n_frames=in.n_sector_frames; %293
    
    %------ call main program --------------------------------------------
    for n=in.base_frame:in.n_frames
        wdir.test_file_list(n,:)=strcat(wdir.test_dir_name,wdir.test_name,'_',num2str_lead0(n-1,3),in.extension);
    end
    [feature,wdir]=cv_klt_20_feat_filt(in,feature,cam,wdir);
    %---get data
    ix=feature.rpy_ix;
    iy=feature.rpy_iy;
    iv=feature.rpy_iv;
    %----build all data from sector features --------------------
    [nnn,ttt]=size(ix);
    rpy_ix_all=ix;
    rpy_iy_all=iy;
    rpy_iv_all=iv;
    clear ix iy iv  feature.rpy_ix  feature.rpy_iy  feature.rpy_iv; %for next time
    
    rpy_ix=rpy_ix_all;
    rpy_iy=rpy_iy_all;
    rpy_iv=rpy_iv_all;
    size(rpy_ix_all)
    
    ix=rpy_ix_all;
    iy=rpy_iy_all;
    flen=cam.flen;
    zinit= in.z_init_meters/in.pixel_width_meters;
    
    v=find(ix<-9000); ix(v)=NaN; iy(v)=NaN;
    v=find(ix>9000); ix(v)=NaN; iy(v)=NaN;
    
    test_file_list=wdir.test_file_list;
    save(klt_outfile,'rpy_ix','rpy_iy','rpy_iv','ix','iy','flen','zinit','test_file_list','in'); %for cir
    disp('after feature extraction ');
    size(rpy_ix)
    size(rpy_iy)
    size(rpy_iv)
end

%333 display and plotting 3333333333333333333333333333333333333333
if in.klt_stage <=3
    %---------- all data ready for plotting -----------------
    load(klt_outfile);
    
    rpy_ix_all=rpy_ix;
    rpy_iy_all=rpy_iy;
    rpy_iv_all=rpy_iv;
    [nnn,ttt]=size(rpy_iv_all)
    
    if  in.klt_display_tag >=1 %display features map
        figure(121)
        clf
        imagesc(rpy_iv_all)
        plot_title('cv_klt.m: rpy_iv_all')
        
        figure(122)
        clf
        imagesc(rpy_ix_all)
        plot_title('cv_klt.m: rpy_ix_all')
        
        %----------------------------------------------------------------------
        plot_title(sprintf('after feature extraction rpy_ix_all features_val_map, n_features =%d,frame_t=%d',nnn,ttt));
        %-------all data are ready ----------------------display end -----
    end
    if in.klt_display_tag >=2 %show step by step
        for t=1:ttt
            texture_file_list(t,:)=...
                strcat(wdir.test_dir_name,wdir.test_name,'_',num2str_lead0(t-1,3),in.extension);
        end
        cv_klt_21_show_feats(...
            rpy_ix_all,rpy_iy_all,rpy_iv_all,in,cam,wdir,feature,texture_file_list);
    end
end

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp(' file saved into klt_data ')
disp('rpy_ix, rpy_ix, roy_iv, unused code < -9000')
disp('ix,iy unused code= nan')
disp('flen=focal length and zinit=initia_depth saved')
disp('    save klt_data rpy_ix rpy_iy rpy_iv ix iy flen zinit; %for cir')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')

