%$$function [im_first,im_anchor]=show_imgseq_features(...
%%   first_frame_pointer,anchor_frame_pointer,wdir.test_dir_name, file_head,in.extension,...
% iix,iscr_iy,screen_max_x,screen_max_y,ixcenter,scr_iycenter,display_mode,features_xy_limits)
function ct_21_show_feats(ix,iy,iv,in,cam,wdir,feature,texture_file_list);

%------------------------------------------------
%Set parameters
%------------------------------------------------
make_avi_movietag=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[scr_ix,scr_iy,scr_iv]=cv_rpy2scr_features(ix,iy,iv,cam,feature);

[foo,n_frames]=size(scr_ix);

%wdir.test_file_list
%-----------------------------------------------------------------------------------------------------
[nnn,ttt]=size(scr_ix);
% figure(20)
% clf
% hold on
figure(131)
clf
hold on

%for t=1:ttt-1
if make_avi_movietag==1
    mov = avifile('0_output1.avi')
end

for t=1:ttt-1
    
    im=imread(texture_file_list(t+1,:));
     axis ij
     image(im)
     for n=1:nnn
        if  scr_iv(n,t) > 0 % a new feature 
            if  scr_iv(n,t+1) < -9000 % (next ) will be lost feature 
                plot(scr_ix(n,t),scr_iy(n,t),'g*','MarkerSize',in.markersize_features);  %ignor -90xx control tag
                plot(scr_ix(n,t),scr_iy(n,t),'go','MarkerSize',in.markersize_features);  %ignor -90xx control tag
            else
                plot(scr_ix(n,t),scr_iy(n,t),'r*','MarkerSize',in.markersize_features);  %ignor -90xx control tag
                plot(scr_ix(n,t),scr_iy(n,t),'ro','MarkerSize',in.markersize_features);  %ignor -90xx control tag
            end
        end
        if  scr_iv(n,t) ==0 % continuos feature 
                  plot(scr_ix(n,t),scr_iy(n,t),'b*','MarkerSize',in.markersize_features);  %ignor -90xx control tag
            plot(scr_ix(n,t),scr_iy(n,t),'bo','MarkerSize',in.markersize_features);  %ignor -90xx control tag
        end
    end
    plotbox(in.features_xy_limits(1),in.features_xy_limits(3),...
        in.features_xy_limits(2),in.features_xy_limits(4),'y');
    
    plot_title(sprintf('time=%d,n_features =%d,total_frames=%d,in.markersize_features=%d',t,nnn,ttt,in.markersize_features));
    texture_file_list(t+1,:)
    disp(sprintf('time=%d,n_features =%d,total_frames=%d,in.markersize_features=%d',t,nnn,ttt,in.markersize_features));
    plot_title('cv_klt_show_feats.m :features')
    if make_avi_movietag==1
        pause(0.1)
        F(t) = getframe;
    else
        pause
    end
end
if make_avi_movietag==1
    mov = addframe(mov,F);
    movie(F);
    mov = close(mov);
end


