%kh wong,2002 May 9  copy right reserved
%image to pgm file formate
%usage im2pgm3(dir_name, file_head,MAX_T,hand_click,%Max_corners_required);
%example im2pgm3('C:\test_images\lab\', 'labb',18,1);
%example im2pgm3('C:\test_images\lab\', 'labb',19,2)
%-- index_format=1: file name index with no leading 0;   -----------------
%-- index_format=2: file name index with leading 0;   -----------------
%
%default output directory is 'c:\test_images\temp_pgm\'; filenames imgxx.pgm
%
function im2pgm(dir_name, file_head,extension,first_frame_pointer,n_frames,out_directory);

%im2pgm9(index_model,dir_name,file_head,extension,first_frame_index(index_model),...
%         n_frames,out_directory); %convert image (.jpg or .bmp) into .pgm

dir_name
file_head
n_frames

directory_head=dir_name;

head1=strcat(directory_head,file_head,'00');%If you change Temp to new, set new000
head2=strcat(directory_head,file_head,'0');%If you change Temp to new, set new00
head3=strcat(directory_head,file_head);%If you change Temp to new, set new00

%hardcoded parmameters----------------------------------
frame_step=1;
%first_frame_pointer=0;
%-----------------------------------------------------

for frame_t=1:n_frames,
    %--------------get next frame begins ------------------------------------------------
    %%% get and read img file
    i= (frame_t -1)*frame_step + first_frame_pointer ; %will start from 0
    jj= (frame_t -1)*frame_step + 0 ; %the phm index always starts from 0
    %------------------------------- handle input file indexes ---------------
    if i <10   %do not touch
        in_filename=strcat(head1,num2str(i));
    else
        if i<100 %do not touch
            in_filename=strcat(head2,num2str(i));
        else
            if i<1000 %do not touch
                in_filename=strcat(head3,num2str(i));
            end
        end
    end
    im0=double(rgb2gray(imread(strcat(in_filename,extension))));
    im=double(im0);
    
    %------------------------------- handle output .pgm file indexes ---------------
    %output pgm
    %------- format 2, fle name index with leading 0   -----------------
    if jj <10   %do not touch
        outpgm_filename=strcat(out_directory,'img00',num2str(jj),'.pgm'); %from 0 to max-1
    else
        if jj<100 %do not touch
            outpgm_filename=strcat(out_directory,'img0',num2str(jj),'.pgm'); %from 0 to max-1
        else
            if jj<1000 %do not touch
                outpgm_filename=strcat(out_directory,'img',num2str(jj),'.pgm'); %from 0 to max-1
            end
        end
    end
    disp(sprintf('Im2pgm:%s to %s',in_filename,outpgm_filename));
    
    
    %-------------------------------
    % im is already a binary image, so binaries it and save
    %figure(300)
    %clf
    %frame_t
    %size(im)
    % imagesc(im)
    %'test5123',pause
    sub_savepgm1(outpgm_filename,im);
end ;
disp('im2pgm completed');

%%%%%%%%%%%% from
%SAVEPGM	Write a PGM format file
%
%	SAVEPGM(filename, im)
%
%	Saves the specified image array in a binary (P5) format PGM image file.
%
% SEE ALSO:	loadpgm
%
%	Copyright (c) Peter Corke, 1999  Machine Vision Toolbox for Matlab


% Peter Corke 1994
%modified by khwong

function sub_savepgm1(fname, im_input)
im=im_input;

fid = fopen(fname, 'w');
[r,c] = size(im');
fprintf(fid, 'P5\n');
fprintf(fid, '%d %d\n', r, c);
fprintf(fid, '255\n');
fwrite(fid, im', 'uchar');
fclose(fid)
