%1) error for time =1 is flase and can not be compared with lowe202
%   for it has initmodel to setlle it. so don't count it
%2) real trach internal loop here is 5, what is that in lowe202
%
%real_track3:  superceded real_track3_v0
%add valid/invalid array for feature points
%simplified the program, michael's version 020529

%function [approx_model,angle,error]=realtrack(ix,iy)
function [model,RT_solutions,error_trucco_all_time,cputime_error2,mse_error_model_pixels2_loop]=...
    lowe201(init_model_type,index_model,nloop,ix,iy,screen_max_x, screen_max_y,...
    ixcenter,iycenter,n_model_line_x,matlab_version,fLen,init_center,centered_real_model,test_i)

[N T] = size(ix);

%I think if the object is 0.4 meters away from the cam, pixel-with=5.42um, tz=0.4/5.4um=73800
init_z=init_center(3);

%init RT matrix (size 6*T)
RT_solutions = zeros(6,T);
RT_solutions(3,1) = init_z;     %init z displacement of the 1st frame


%init model (size 3*N)
switch init_model_type
    case 'planar'
        model = zeros(3,N);   %model = 3*N
        model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
        model = (RT_solutions(3,1)/fLen) .* model;
    case 'convex'; %ie convex boject, center is negative, outside is 0, example: box
        model = zeros(3,N);   %model = 3*N
        %model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
        model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
        model = (RT_solutions(3,1)/fLen) .* model;
        dd=sqrt(ix(:,1).^2+iy(:,1).^2);  %for concave objects init values
        model(3,:) =50*(dd-max(dd))'; %50 is arbitrarty, scale up from uv(2d) to xy(3d) space
    case 'concav'; %ie concav boject, center is o, outsie is negative, example:  corridor
        model = zeros(3,N);   %model = 3*N
        %model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
        model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
        model = (RT_solutions(3,1)/fLen) .* model;
        dd=sqrt(ix(:,1).^2+iy(:,1).^2);  %for convex objects init values
        model(3,:) =50*(-1*dd)'; %50 is arbitrarty, scale up from uv(2d) to xy(3d) space
    otherwise
        disp('unknown init_model_type???, please check real_track'),pause
end

figure(422)
clf
plot3(model(1,:),model(2,:),model(3,:),'g.');
title('Init_model')
rotate3d on
xlabel('x-axis');
ylabel('y-axis');
zlabel('z-axis');
plot_title('cv_lowe201.m : model3d')

trucco_nloop=5;%5,

t0=cputime;
for loop=1:nloop %
    %step 1 : find pose
    for t=1:T
        if RT_solutions(3,t) == 0     %if uninitialised
            RT_solutions(:,t) = RT_solutions(:,t-1);  %use prev value as initial estimate
        end
        
        [RT_solutions(:,t),error_trucco,rx,ry] = ...
            trucco(model, ix(:,t), iy(:,t), RT_solutions(:,t), fLen, trucco_nloop);  %pass all valid points in tth frame
        
        err_trucco_looptime(loop,t)=error_trucco; %error_trucco per feature per frame
    end
    error_trucco_all_time(loop)=sum(err_trucco_looptime(loop,2:T))/T; %from 2 to avoid noise,err_trucco_looptime is per feature per frame
    cputime_error2(loop)=cputime-t0;
    % plot(error_trucco_all_time)
    disp(sprintf('Realtrack,test_i=%d,index_model=%d,loop=%d,error_trucco_all_time=%f',...
        test_i,index_model,loop,error_trucco_all_time(loop)));
    
    constraint = RT_solutions(4:6,1);   %get angle of 1st image
    RT_solutions(4:6,:) = RT_solutions(4:6,:) - repmat(constraint,1,T);
    
    %step 2 : find model
    model = backproject(model, ix, iy, fLen, RT_solutions,trucco_nloop);
    
    %        centered_real_model=model(:,:,1)-repmat(init_trans,1,n_features_per_frame);
    
    dtmp= centered_real_model(:,:)-model(:,:);
    mse_error_model_pixels2=(1/N) *  sum(sum(dtmp.^2));
    %      percenage_structure_error=...
    %         (pixel_width_meters* sqrt(mse_error_model_pixels2)/object_width_meters)*100
    %disp(sprintf('model structure percenage_error per feature is %f percents',percenage_structure_error));
    %    percenage_structure_error_loop(loop)=percenage_structure_error;
    mse_error_model_pixels2_loop(loop)=mse_error_model_pixels2;
end

%-------------------------------------------------
figure(430)
clf
hold on
plot(error_trucco_all_time,cputime_error2,'kx-')
plot_title('cv_lowe201.m: r+- is lowe202; kx- is lowe201');
'current test:Total 2D image residue error, all features and time frames after each iteration' 
xlabel('Cputime');
ylabel('Total 2D image residue error in pixels');

%axis([0 2*max(cputime_error2) 0 1]);


%------------------------------------------------
figure(431)
clf
subplot(3,1,1)
plot(error_trucco_all_time,'kx-')
plot_title('cv_lowe201.m ::Total 2D image residue error, all features and time frames after each iteration' )
xlabel('Iterations');
ylabel('Total 2D image residue error in pixels');
%axis auto

subplot(3,1,2)
plot(error_trucco_all_time,'kx-')
axis([0 nloop 0 1]);
title('current test:sub-range:Total 2D image residue error,all features and time frames after each iteration' )
xlabel('Iterations');

subplot(3,1,3)
plot(error_trucco_all_time,'kx-')
axis([0 nloop 0 0.5]);
title('current test:sub-range:Total 2D image residue error,all features and time frames after each iteration' )
xlabel('Iterations');


%-----------------------------------------------------------
figure(432)
clf
%subplot(3,1,3)
plot(mse_error_model_pixels2_loop,'k*-')
plot_title('cv_lowe201.m: mse error model pixels2 loop(loop)' )
xlabel('Iterations');
ylabel('mse error');

%figure(52)
%clf
%hold on

%u_model=fLen.*model(1,:)./(model(3,:)+init_center(3));
%v_model=fLen.*model(2,:)./(model(3,:)+init_center(3));

%plot(ix(:,1),iy(:,1),'r+');
%plot(u_model,v_model,'bx');
%title('ix(:,1), iy(:,1) red r+;  u model,v model=bx')


figure(453)
clf
hold on

u_rx=(screen_max_x - rx) + 1 - ixcenter;
v_ry=(screen_max_y - ry) + 1 - iycenter;
plot(u_rx,v_ry,'rx');


u_ix=(screen_max_x - ix) + 1 - ixcenter;
v_iy=(screen_max_y - iy) + 1 - iycenter;
plot(u_ix(:,T),v_iy(:,T),'g+');
plot_title(sprintf('cv_lowe201.m: reporjected u-rx,v-ry :red-x; original u_ix,u_iy: g+, frame-t=T=%d',T));




figure(441)
clf

scatter3(model(1,:),model(2,:),model(3,:),'*');
plot_title('cv_lowe201.m: found_model')
rotate3d on
xlabel('x-axis');
ylabel('y-axis');
zlabel('z-axis');
%texture mapping
%x=model(1,:);
%y=model(2,:);
%z=model(3,:);

%tri = delaunay(x,y);    %not so satisfactory, triangulate based only on x and y
%trimesh(tri,x,y,z);
%pause;

save ('zdata','init_z','model','ix','iy','ixcenter','iycenter','RT_solutions');
return;

%ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
%%%%%%%%%% functions  %%%%%%%%%%%%%%%
%ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff


function [Solution,error_trucco,rx,ry] = ...
    trucco(model, x, y, Solution, fLen, numIter)
lambda = 0.001;
eye_mat = eye(6,6);

for i = 1:numIter
    [rx,ry,err, Jacob]=mytrucco(Solution,model,x,y,fLen);
    Jerr = Jacob'*err;
    JJacob = Jacob'*Jacob;           %JJacob size = 6*6
    LM = lambda*eye(6,6);
    JJacob = JJacob+JJacob.*LM;    %add the Levenberg-Marquardt term
    delta = JJacob\Jerr;
    temp = Solution + delta;         %temp is the new solution
    [new_rx,new_ry,new_error,job] = mytrucco(temp,model,x,y,fLen);  %see if the new solution is good
    if norm(new_error) <= norm(err)
        Solution = temp;        %error is reduced, use new solution
        lambda = lambda/10;
        ss_error=new_error;
        rx=new_rx;
        ry=new_ry;
    else
        lambda = lambda*10;     %error not reduced, keep old solution
        ss_error=err;
    end
end

%--- khw add error display------------
N2=size(ss_error);
N=N2/2;
ex=ss_error(1:N);
ey=ss_error(N+1:N2);
len_ex=length(ex);
ss_error=sqrt(   sum((ex.^2)+(ey.^2))/len_ex   ); %mean value for each feature

%in lowe202 >> e = sqrt(sum(v.^2)/(length(v)/2));
%     size(ss_error);
%	  error_trucco(i,:)=ss_error;
error_trucco=ss_error;
%size(ex)
%size(ey)
%size(ss_error)
%     plot(error_trucco);
%     title('err trucco');
%     pause
return

function [rx,ry,err,Jacob] = mytrucco(Solution,model,x,y,fLen)

[temp N] = size (model);  %model size = 3*N
%x and y are of size N*1

x = x';  %makes size = 1*N
y = y';
rx = zeros(1,N);
ry = zeros(1,N);
err = zeros (2*N, 1);
Jacob = zeros (2*N, 6);

% Extract the initial estimates for the parameters.

%for iter = 1:numIter
T = repmat(Solution(1:3), 1, N);
Rot = rpyMat(Solution(4:6));

RM = Rot * model;
XM = RM(1,:);
YM = RM(2,:);
ZM = RM(3,:);
P = RM + T;    %P=size 3*n
X = P(1,:);
Y = P(2,:);
Z = P(3,:);

rx = fLen .* X ./ Z;
ry = fLen .* Y ./ Z;
Dif = [x-rx; y-ry];  %Dif of size 2*N; Dif = ActualImg - ReconImg;
err = [ Dif(1,:)'; Dif(2,:)' ];

if nargout > 1   %if nargout==1, only compute the error
    XY = X.*Y;  %parameters in newton's method
    XX = X.*X;
    YY = Y.*Y;
    ZZ = Z.*Z;
    
    dxdt1 = fLen./Z;
    z0 = zeros(1,N);
    dxdt3 = -fLen.*X./ZZ;   %CAUSE OF INSTABILITY X/Z < 0.1, so dxdt3 < dxdt1, making t3 more important
    dxdalpha = -fLen.*X.*YM./ZZ;
    dxdbeta = fLen.*((X.*XM+Z.*ZM)./ZZ);
    dxdgamma = -fLen*(YM./P(3,:));
    
    dydt2 = dxdt1;
    dydt3 = -fLen.*Y./ZZ;
    dydalpha = -fLen*((Z.*ZM+Y.*YM)./ZZ);
    dydbeta = fLen*(XM.*Y./ZZ);
    dydgamma = fLen.*XM./Z;
    
    Jacob = [ dxdt1' z0' dxdt3' dxdalpha' dxdbeta' dxdgamma'; z0' dydt2' dydt3'  dydalpha' dydbeta' dydgamma' ];
end

return

function Model = backproject(Model, ix, iy, fLen, solutions, numIter)
%solutions = size 6*T, [disp, rot] * T sequences
[N T] = size(ix);
Jacob = zeros(2*T, 3, N);
err = zeros(2*T, N);
JJacob = zeros(3,3);
Jerr = zeros(2*T,1);
LM = zeros(3,3);
eye_mat = eye(3,3);
lambda = 0.001*ones(1,N);
temp_model = zeros(3,N);

for iter = 1:numIter
    [err,Jacob]=my_backproject(Model,ix,iy,fLen,solutions);
    for i = 1:N                         %process all N points
        Jerr = Jacob(:,:,i)'*err(:,i);
        JJacob = Jacob(:,:,i)'*Jacob(:,:,i);           %JJacob size = 6*6
        LM = lambda(i)*eye_mat;
        JJacob = JJacob+JJacob.*LM;    %add the Levenberg-Marquardt term
        delta = JJacob\Jerr;
        %Model(:,i) = Model(:,i) + delta;
        temp_model(:,i) = Model(:,i) + delta;         %temp is the new solution
    end
    
    %LM code
    new_error = my_backproject(temp_model,ix,iy,fLen,solutions);  %err size is 2T*N
    for i = 1:N
        if norm(new_error(:,i)) <= norm(err(:,i))
            Model(:,i) = temp_model(:,i);        %error is reduced, use new solution
            lambda(i) = lambda(i)/10;
        else
            lambda(i) = lambda(i)*10;     %error not reduced, keep old solution
        end
    end
end
return

function [err,Jacob] = my_backproject(Model, ix, iy, fLen, solutions)
%solutions = size 6*T, [disp, rot] * T sequences
[N T] = size(ix);
RMod = zeros(3,N);
Jacob = zeros(2*T, 3, N);
P = zeros(2,N);
err = zeros(2*T, N);

for t = 1:T
    disp = solutions(1:3,t);
    Rot = rpyMat(solutions(4:6,t));
    RMod = Rot*Model+repmat(disp,1,N);
    X = RMod(1,:);
    Y = RMod(2,:);
    Z = RMod(3,:);
    
    P(1,:) = fLen.*X./Z;
    P(2,:) = fLen.*Y./Z;
    err(2*t-1,:) = ix(:,t)' - P(1,:);   %model-observed image
    err(2*t,:)   = iy(:,t)' - P(2,:);   %model-observed image
    
    if nargout > 1  %if nargout==1, only compute the error
        Z2 = Z.*Z;
        XZ2 = X./Z2;
        YZ2 = Y./Z2;
        Jacob(2*t-1,1,:) = fLen .* ( Rot(1,1)./Z - Rot(3,1).*XZ2 );
        Jacob(2*t-1,2,:) = fLen .* ( Rot(1,2)./Z - Rot(3,2).*XZ2 );
        Jacob(2*t-1,3,:) = fLen .* ( Rot(1,3)./Z - Rot(3,3).*XZ2 );
        Jacob(2*t,  1,:) = fLen .* ( Rot(2,1)./Z - Rot(3,1).*YZ2 );
        Jacob(2*t,  2,:) = fLen .* ( Rot(2,2)./Z - Rot(3,2).*YZ2 );
        Jacob(2*t,  3,:) = fLen .* ( Rot(2,3)./Z - Rot(3,3).*YZ2 );
    end
end
return

function R = rpyMat(angle)
%R = e2r(angle);
%R = eul2dcm(angle);
%R = trucco_rpyMat(angle);
R = e2r_old(angle);
return

function R=trucco_rpyMat(angle)
ca = cos(angle(1));
cb = cos(angle(2));
cc = cos(angle(3));
sa = sin(angle(1));
sb = sin(angle(2));
sc = sin(angle(3));

R = [ cb*cc -cb*sc sb;
    sa*sb*cc+ca*sc  -sa*sb*sc+ca*cc -sa*cb;
    -ca*sb*cc+sa*sc ca*sb*sc+sa*cc ca*cc];
return;

function R=e2r_old(angle)
%angle = [phi, theta, psi]
%phi = rotation around x-axis (so that position of x is not changed)
%theta = rotation around y axis
%psi: right hand screw rule

%OLD VERSION: suspect has problem with x-axis
alpha = angle(1);
beta = angle(2);
gamma = angle(3);
R1 = [ 1  0  0;  0 cos(alpha) -sin(alpha); 0 +sin(alpha) cos(alpha)];
R2 = [ cos(beta) 0 sin(beta);  0  1  0;  -sin(beta)  0  cos(beta)];
R3 = [ cos(gamma) -sin(gamma) 0;  sin(gamma) cos(gamma) 0;  0  0  1];

R = R1 * R2 * R3;
return

function R=e2r_new(angle)
%old version is better!
%angle = [phi, theta, psi]
%phi = rotation around x-axis (so that position of x is not changed)
%theta = rotation around y axis
%psi: right hand screw rule

%New VERSION: based on camera model (x->left, y->up, z->into paper
alpha = angle(1);
beta = angle(2);
gamma = angle(3);
R1 = [ 1  0  0;  0 sin(alpha) cos(alpha); 0 cos(alpha) -sin(alpha)];
R2 = [ -sin(beta) 0 cos(beta);  0  1  0;  cos(beta)  0  sin(beta)];
R3 = [ sin(gamma) cos(gamma) 0;  cos(gamma) -sin(gamma) 0;  0  0  1];
R = R1 * R2 * R3;
return


