%function viewer( F, img1, img2 )
% viewer( F, img1, img2 )
%   displays epipolar lines corresponding to points clicked in 
%   img1. Right-click to end

% if exist('h1')
%     figure(h1)
% else
%     h1 = figure;
% end    
load computeF_data
load klt_data

figure(1)
clf reset
i1 = imshow( img1 );
set( i1, 'HandleVisibility', 'off' );
xlabel('Right click to end');
hold on


% if exist('h2')
%     figure(h2)
% else
%     h2 = figure;
% end

figure(2)
clf reset
i2 = imshow(img2);
hold on
set( i2, 'HandleVisibility', 'off' );

b = 0;
e = null(F);
imsize = [size(img1,2) size(img1,1)];
%while b~=3
figure(1)

[iii,foo]=size(ix);

%--- for display ------------------------------------------------------
display_tag=0;
if display_tag==1
for i=1:10:iii
%for i=1:3
    %------ 1 -----------------------------------------
    px1=640-ix(i,1)+1 - (640/2); %adjust to rpy corrdinate
    py1=480-iy(i,1)+1 - (480/2); %adjust to rpy corrdinate
    x1 = [px1 py1 1];   
    
    s1 = clipline( cross(e,x1)', imsize);
    
    figure(1)
    plot( s1(:,1), s1(:,2), 'c-' );
    plot( px1, py1, 'r.' );
    
    figure(2); %  cla
    
    %figure(h2), cla    
    s2 = clipline( F * x1', imsize );
    plot( s2(:,1), s2(:,2), 'y-' );
    
    %------ 2 ---------------------------------------
    px2=640-ix(i,2)+1 - (640/2); %adjust to rpy corrdinate
    py2=480-iy(i,2)+1 - (480/2); %adjust to rpy corrdinate
    x2 = [px2 py2 1];    
    plot( px2, py2, 'r.' );
    
    %%------- find dist -----------------
    xx1=s2(1,1);
    yy1=s2(1,2);
    
    xx2=s2(2,1);
    yy2=s2(2,2);
    
    xx1
    yy1
    xx2
    yy2
    px2
    py2
    
    [d,cx,cy]=dist_point_line(xx1,yy1,xx2,yy2,px2,py2);
    dist(i)=d;
    line([cx,px2],[cy,py2]); %plot the small normal vector
 end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%for i=1:10:iii
for i=1:iii
    %------ 1 -----------------------------------------
    px1=640-ix(i,1)+1 - (640/2); %adjust to rpy corrdinate
    py1=480-iy(i,1)+1 - (480/2); %adjust to rpy corrdinate
    x1 = [px1 py1 1];   
    
    s1 = clipline( cross(e,x1)', imsize);
    
%     figure(1)
%     plot( s1(:,1), s1(:,2), 'c-' );
%     plot( px1, py1, 'r.' );
%     
%     figure(2); %  cla
%     
    %figure(h2), cla    
    s2 = clipline( F * x1', imsize );
 %   plot( s2(:,1), s2(:,2), 'y-' );
    
    %------ 2 ---------------------------------------
    px2=640-ix(i,2)+1 - (640/2); %adjust to rpy corrdinate
    py2=480-iy(i,2)+1 - (480/2); %adjust to rpy corrdinate
    x2 = [px2 py2 1];    
%    plot( px2, py2, 'r.' );
    
    %%------- find dist -----------------
    xx1=s2(1,1);
    yy1=s2(1,2);
    
    xx2=s2(2,1);
    yy2=s2(2,2);
    
    [d,cx,cy]=dist_point_line(xx1,yy1,xx2,yy2,px2,py2);
    dist(i)=d;
 %   line([cx,px2],[cy,py2]); %plot the small normal vector
 end

%%%%%%%%%%%%%%%% actual filter %%%%%%%%%%%%
threshold_epip_error=0.6;

for i=1:iii
    if dist(i) > threshold_epip_error
        ix(i,1)=nan;    
    end
end
pause