%based on viewer.m
function ep_filter_from_corr
%keep this order
load computeF_data
load klt_data
load ba_inpar

%show_ep_features

clear raw_ix raw_iy % for this corr method klt data is cleared first
%raw_ix=zeros(2000,in.n_sector_frames); %make the program run faster
%raw_iy=zeros(2000,in.n_sector_frames);

for tt=1:in.n_sector_frames-2
    file1 = test_file_list(tt,:);
    file2 = test_file_list(tt+1,:);
    x=x_seq{tt};
    xp=xp_seq{tt};
    
    figure(431)
    clf
    hold on
    img1 = imread(file1);
    img2 = imread(file1);
    image(img1)
    axis ij
    [nnn,foo]=size(x);
    % 111111111111111111  handle the the first frame
    if tt==1
        for n=1:nnn
            %        plot(x(n,1),x(n,2),'r.');
            raw_ix(n,1)=x(n,1);
            raw_iy(n,1)=x(n,2);
            raw_ix(n,2)=xp(n,1);
            raw_iy(n,2)=xp(n,2);
        end    
    else  %%%% tt=2 or above
        [mmm,foo]=size(raw_ix);
        add_ct=0;
        for n=1:mmm
            %  n
            x1=raw_ix(n,tt);
            y1=raw_iy(n,tt);
            % dd=abs(xp(:,1)-xx)+abs(xp(:,2)-yy)
            dd=sqrt(   (x(:,1)-x1).^2 + (x(:,2)-y1).^2  );
            [Y,I]=min(dd);
            
%            if 0.5<Y & Y<7
            d2= sqrt ( (x(I,1)-xp(I,1))^2 + (x(I,2)-xp(I,2))^2 ); 
            if  Y<7 & 1<d2 & d2<7 
%            if   0.1<d2 & d2<7 
                % dd(I)
                raw_ix(n,tt+1)=xp(I,1);
                raw_iy(n,tt+1)=xp(I,2);
            else
                raw_ix(n,tt+1)=nan;
                raw_iy(n,tt+1)=nan;
            end
            %             tt
            %             n
            %                 x1
            %             raw_ix(n,tt+1)
            %             y1
            %             raw_iy(n,tt+1)
            %             pause
            %             else
            %                                 add_ct=add_ct+1;
            %                                 raw_ix(mmm+add_ct,1:tt-1)=nan; %clear unused raw_ix before current time
            %                                 raw_iy(mmm+add_ct,1:tt-1)=nan; %clear unused raw_ix before current time
            %                                 
            %                                 raw_ix(mmm+add_ct,tt)=x(n,1); %filll in new feature
            %                                 raw_iy(mmm+add_ct,tt)=x(n,2);
            %                                 raw_ix(mmm+add_ct,tt+1)=xp(n,1);
            %                                 raw_iy(mmm+add_ct,tt+1)=xp(n,2);
            %             end
            
        end    
    end
    'press key to continue, inside show_ep_features'
    tt
    %pause
end
xmax=cam.screen_max_x;
ymax=cam.screen_max_y;
ix=raw_ix-(xmax/2);
iy=raw_iy-(ymax/2);
save('ep_filter_data_from_corr','ix','iy','flen','zinit','test_file_list','in'); %for cir


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%x=x_seq{ii};
%xp=xp_seq{ii};
[nnn,ttt]=size(raw_ix);
for t=1:ttt-1
    file1 = test_file_list(t,:);
    file2 = test_file_list(t+in.nF_step,:);
    figure(431)
    clf
    hold on
    img1 = imread(file1);
    img2 = imread(file1);
    image(img1)
    axis ij
    for n=1:nnn
        %        plot(x(n,1),x(n,2),'r.');
        [raw_ix(n,t),raw_ix(n,t+1)],[raw_iy(n,t),raw_iy(n,t+1)]
        line([raw_ix(n,t),raw_ix(n,t+1)],[raw_iy(n,t),raw_iy(n,t+1)]);
        %        plot(xp(n,1),xp(n,2),'b.');
        %             %if t>1
        %                 t
        %                 pause
        %                 %end
    end
    'press key to continue, inside next frame'
    %pause
end

