%based on viewer.m
function ep_filter_from_klt
%keep this order
load computeF_data
load klt_data
load inpar

%threshold_epip_error=in.threshold_epip_error; %in pixels

[foo,foo,n_Fseq]=size(Fseq);

%for frame=1:n_Fseq-in.nF_step %for the whol eseg
for frame=1:n_Fseq %for the whol eseg
    disp('epipolar filtering dist calculation')
    frame
    F=Fseq(:,:,frame); %get F
    b = 0;
    e = null(F);
    img1=imread(test_file_list(1,:)); %added
    imsize = [size(img1,2) size(img1,1)];
    %while b~=3
   % figure(1)
    [maxy,maxx,foo]=size(img1);
    [nfeats,foo]=size(ix);
    
    for i=1:nfeats
        %------ 1 -----------------------------------------
        px1=maxx-ix(i,frame)+1 - (maxx/2); %adjust to rpy corrdinate
        py1=maxy-iy(i,frame)+1 - (maxy/2); %adjust to rpy corrdinate
        x1 = [px1 py1 1];   
        
        s1 = clipline( cross(e,x1)', imsize);
        
        %     figure(1)
        %     plot( s1(:,1), s1(:,2), 'c-' );
        %     plot( px1, py1, 'r.' );
        %     
        %     figure(2); %  cla
        %     
        %figure(h2), cla    
        s2 = clipline( F * x1', imsize );
        %   plot( s2(:,1), s2(:,2), 'y-' );
        
        %------ 2 ---------------------------------------
        px2=maxx-ix(i,frame+in.nF_step)+1 - (maxx/2); %adjust to rpy corrdinate
        py2=maxy-iy(i,frame+in.nF_step)+1 - (maxy/2); %adjust to rpy corrdinate
        x2 = [px2 py2 1];    
        %    plot( px2, py2, 'r.' );
        
        %%------- find dist -----------------
        xx1=s2(1,1);
        yy1=s2(1,2);
        
        xx2=s2(2,1);
        yy2=s2(2,2);
        
        [d,cx,cy]=dist_point_line(xx1,yy1,xx2,yy2,px2,py2);
        dist(i,frame)=d;
        %   line([cx,px2],[cy,py2]); %plot the small normal vector
    end
end

%%%%%%%%%%%%%%%% actual filter %%%%%%%%%%%%
n_removed=0;
n_accepted=0;
%for frame=1:n_Fseq-in.nF_step%for the whol eseg
for frame=1:n_Fseq%for the whol eseg
    'actual filtering'
    frame
    for i=1:nfeats
        if  dist(i,frame) > in.threshold_epip_error
            ep_filtered_ix(i,frame)=nan;    
            ep_filtered_iy(i,frame)=nan; 
            n_removed=n_removed+1;
%             i
%             frame
%             dist(i,frame)
%             pause
            
        else
            ep_filtered_ix(i,frame)=ix(i,frame);    
            ep_filtered_iy(i,frame)=iy(i,frame);    
            n_accepted=n_accepted+1;
        end
    end
end

%%remove row with very short or no valid data
[iii,nnn]=size(ep_filtered_ix);
new_i=0;
length_threshold=2;
for i=1:iii %filter rowe of efatures that have little vlaid values
    [I,J,V]=find(~isnan(ep_filtered_ix(i,:)));
    if length(I) >length_threshold
        '----LLLL lone ------'
%        ep_filtered_ix(i,:)
%         length(I)
%         pause
        new_i=new_i+1;  
        ep_filtered_ix2(new_i,:)=ep_filtered_ix(i,:);
        ep_filtered_iy2(new_i,:)=ep_filtered_iy(i,:);
        %   else
         '---short-----'
 %        ep_filtered_ix(i,:)
         %length(I)
 %        pause
   end
end

% in.threshold_epip_error
% n_removed
% n_accepted
% 

size(ep_filtered_ix2)
size(ix)

clear ix iy 
ix=ep_filtered_ix2;
iy=ep_filtered_iy2;

size(ep_filtered_ix)
size(ep_filtered_ix2)
size(ix)
save('ep_filter_data_from_klt','ix','iy','flen','zinit','test_file_list','in'); %for cir
 

