function [gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3]=show_motion
load rb_path
%11111111111111111111111111111111111111111111111111111111111111
N_steps=length(motion);


gt_x=acc_motion_x; %gt=ground truth
gt_y=zeros(1,N_steps); %no y-motion
gt_z=acc_motion_z;
gt_an1=zeros(1,N_steps); %no 
gt_an2=acc_motion_an2;
gt_an3=zeros(1,N_steps); %no 


%%%%%%%%%%%%%%%%%%% plot top down view path %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1)
clf
hold on
max_d=0.03; %in meters
plot(-max_d,0,'k.');% make sure xy appears in the same magnitude
plot(max_d,max_d,'k.');% make sure xy appears in the same magnitude
% for i=1:N_steps-1
%    plot(gt_x,gt_z,'rs')
% end
text(tdview_x(1)+0.002,tdview_z(1)+0.002,'time =1')
text(tdview_x(100)+0.002,tdview_z(100),'time =100')

for i=1:N_steps-1
    plot(tdview_x,tdview_z,'k^')
end

ylabel('Z-axis in meters')
xlabel('X-axis in meters')
title('top down view of the robot motion')

%2222 plot individual rt 22222222222222222222222222222222222222222222222222222222
figure(2)
clf
hold on
subplot(3,1,1);
hold on
for i=1:N_steps-1
    plot(i,gt_x(i),'rx')
end
ylabel('translate-x meters')

subplot(3,1,2);
hold on
for i=1:N_steps-1
    plot(i,gt_z(i),'gx')
end
ylabel('translate-z meters')

subplot(3,1,3);
hold on
for i=1:N_steps-1
    plot(i,gt_an2(i)*180/pi,'bx')
end
ylabel('motion-an2 degree')
xlabel('ground truth: : motion parameter vs time plots')
