function [gt_x,gt_y,gt_z,gt_an1,gt_an2,gt_an3]=rb_find_gt_motion
load rb_path
%11111111111111111111111111111111111111111111111111111111111111
N_steps=length(motion);

acc_motion_an2(1)=0; %angle 2 rotat vs y-axis
acc_motion_x(1)=0;
acc_motion_z(1)=0;
for i=1:N_steps-1
    acc_motion_an2(i+1)=motion_a(i)+acc_motion_an2(i);
    acc_motion_z(i+1)= acc_motion_z(i)  + motion_z(i)*cos(acc_motion_a(i));
    acc_motion_x(i+1)= acc_motion_x(i) + motion_z(i)*sin(acc_motion_a(i));
%    plot(acc_motion_x,acc_motion_z,'rs','MarkerSize','20')
%    plot(acc_motion_x,acc_motion_z,'rs')
end
gt_x=acc_motion_x; %gt=ground truth
gt_y=zeros(1,N_steps); %no y-motion
gt_z=acc_motion_z;
gt_an1=zeros(1,N_steps); %no 
gt_an2=acc_motion_an2;
gt_an3=zeros(1,N_steps); %no 


%%%%%%%%%%%%%%%%%%% plot top down view path %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1)
clf
hold on
max_d=100; %in mm
plot(-max_d,0,'k.');% make sure xy appears in the same magnitude
plot(max_d,max_d,'k.');% make sure xy appears in the same magnitude
for i=1:N_steps-1
    plot(gt_x,gt_z,'rs')
end
ylabel('z-axis in mm')
xlabel('negative x-axis in mm')
title('ground truth : robot motion simulation')

%2222 plot individual rt 22222222222222222222222222222222222222222222222222222222
figure(2)
clf
hold on
subplot(3,1,1);
hold on
for i=1:N_steps-1
    plot(i,gt_x(i),'rx')
end
ylabel('translate-x mm')

subplot(3,1,2);
hold on
for i=1:N_steps-1
    plot(i,gt_z(i),'gx')
end
ylabel('translate-z mm')

subplot(3,1,3);
hold on
for i=1:N_steps-1
    plot(i,gt_an2(i)*180/pi,'bx')

end
ylabel('motion-an2 degree')
xlabel('ground truth: : motion parameter vs time plots')
