function show_rt(rt,model)
[foo,foo,T]=size(rt);
trans=reshape(rt(:,4,:),3,[]);
%%%%%%%%%%%%%%%%%%% translation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
max_v=max([max(trans(1,:)),max(trans(2,:))]);
min_v=min([min(trans(1,:)),min(trans(2,:))]);
figure(520)
clf
hold on
subplot(3,1,1); plot(trans(1,:),'rx');ylabel('Translation-x'); 
axis([1 T min_v max_v])

subplot(3,1,2); plot(trans(2,:),'go');ylabel('Translation-y');
axis([1 T min_v max_v])

subplot(3,1,3); plot(trans(3,:),'bs');ylabel('Translation-z');
xlabel('ba : frame t , vertical axis in pixels');

%%%%%%%%%%%%%%%%%%%%%% rotation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:T
    an(:,i)=rpyAng(rt(:,1:3,i))*180/pi;
end
max_v=max([max(an(1,:)),max(an(2,:)),max(an(2,:)) ]);
min_v=min([min(an(1,:)),min(an(2,:)),min(an(2,:)) ]);
figure(521)
clf
hold on
subplot(3,1,1); plot(an(1,:),'rx');ylabel('Angle1 ');
axis([1 T min_v max_v])
subplot(3,1,2); plot(an(2,:),'go');ylabel('Angle2 ');
axis([1 T min_v max_v])
subplot(3,1,3); plot(an(3,:),'bs');ylabel('Angle3 ');
axis([1 T min_v max_v])
xlabel('ba : frame t , vertical axis in degrees');

figure(523)
clf
plot3(model(1,:),model(2,:),model(3,:),'r.');
xlabel('x-axis');
ylabel('y-axis');
zlabel('z-axis');
