%    MOVIE(H,...) plays the movie in object H, where H is a handle
%    to a figure, or an axis.
%    MOVIE(H,M,N,FPS,LOC) specifies the location to play the movie
%%    at, relative to the lower-left corner of object H and in
%    pixels, regardless of the value of the object's Units property.
%    LOC = [X Y unused unused].  LOC is a 4-element position
%    vector, of which only the X and Y coordinates are used (the
%    movie plays back using the width and height in which it was
%    recorded).  All four elements are required, however.
%usge: pm('movie_1',times,frame_per_second)
%usge: pm('movie_1')
%usge: pm('movie_books2')
%usge: pm('movie_boxd5')

function pm(fname,times,fps)
error(nargchk(0, 3, nargin));
nargin
if (nargin < 1)
   fname='movie_1';
   times=1;
   fps=1;
elseif (nargin < 2)
   times=1;
   fps=1;
elseif (nargin < 3)
   fps=1;
end

fname

load(fname);

figure(625)

clf
%colormap('default')
%colormap('rgb')
%colormap('default')
colormap(gray(256))
%movie(movie_1,1,3,[640 480 1 1 ]) % MOVIE(M,N,FPS) M=ovie file, N=times, FPS-frame per second
movie(movie_1,times,fps) % MOVIE(M,N,FPS) M=ovie file, N=times, FPS-frame per second
disp('avi file saved')
movie2avi(movie_1,strcat(fname,'.avi'));
delete(strcat(fname,'.mat')) %delete movie_1.mat ,the big movie file
