function gen_vrml_one(vrml_inpar_infile,vrml_model_infile,vrml_display_tag,toggle_inside_out,toggle_external_internal_texture)
%    gen_vrml_one('inpar','lowe2xx_out'); %circular algo and general vrml

load(vrml_inpar_infile);
load(vrml_model_infile);
%model, ix,iy are there in the vrml_model_infile

%%%%%%%%%%%%%%%%%%%% parameter conversion %%%%%%%%%%%%%%%%%%%%%%%%
vrml_texture_fname_head=in.texture_fname_head
vrml_extension=in.extension
vrml_seg_index=[1 1 1 1 ] % not used but still keep it for future use :in.vrml.seg_index
vrml_write_mode=in.vrml.write_mode;

if toggle_inside_out==1
    vrml_inside_out_transform=~in.vrml.inside_out_transform;
else
    vrml_inside_out_transform=in.vrml.inside_out_transform;
end

if toggle_external_internal_texture==1
    vrml_external_internal_texture_mode=~in.vrml.external_internal_texture_mode
else
    vrml_external_internal_texture_mode=in.vrml.external_internal_texture_mode
end
%vrml_inside_out_transform=in.vrml.inside_out_transform;
%vrml_external_internal_texture_mode=in.vrml.external_internal_texture_mode

vrml_zinit= in.z_init_meters/in.pixel_width_meters;

w=find(~isnan(ix(:,vrml_seg_index (1))));
u1=ix(w,vrml_seg_index (1));
v1=iy(w,vrml_seg_index (1));
p1=model(:,w);

cv_gen_vrml_one_v1(p1,u1,v1,vrml_texture_fname_head,vrml_extension,vrml_seg_index,vrml_inside_out_transform,...
    vrml_write_mode,vrml_external_internal_texture_mode,vrml_zinit,vrml_display_tag)
return
