function [n,angle]=rodrigue_inv(dR)
%dR is the rotational difference
A=dR-eye(3);
AA=A'*A;
[V,D]=eig(AA);
[tmp,i]=min(abs(diag(D)));
n = V(:,i);
nn=n*n';
nx=[0 -n(3) n(2); n(3) 0 -n(1); -n(2) n(1) 0];
A = eye(3)-nn;
B = nx;
C = dR(:,:,i)-nn;
A = reshape(A,[],1);     %into column vector
B = reshape(B,[],1);
C = reshape(C,[],1);
J = [A B];
x = J\C;
angle=atan2(x(2),x(1));
return