function angles = rotate_angles(R)  %given R, return the rotated angles from R(:,:,1)
T = size(R,3);      %R=3*3*T
angles=zeros(1,T);
for t=1:T
    r = R(:,:,t)*R(:,:,1)';   %Rn=r*R1 => r=Rn*R1'
    A = 0.5*(r-r');
    a = 0.5*sum(sum(A.^2));
    angles(t) = asin(sqrt(a));
end