%this program does simulation as well control the robot to run, still need
%to claibrate the wheels to haev a better pediction in the simulation
function robot
clear all; % remove
camera_mode=0 %1=cameras in operation, 0=no camera
robot_run_mode=0 %1=run, 0=simulationj only, no robot run
steps_per_photo=2 %steps_per_photo 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%sample script for One video capture card is installed.
% realtime image processing example just process diff at Red image
%Initialization mode

%gerente motion sequence
%%%%%%%%% need to calibrate again for more accurate simulation%%%%%%%%%%%
%the following pair must be calibrated together, given a particular
%motor_control_paramter=50, find steps_for_one_revolution for one wheel revolution
%1) done on 2005 3.3 : motor_control_paramter=50 ,steps_for_one_revolution=520
%2) done on 2005 3.3 : motor_control_paramter=100 ,steps_for_one_revolution=260
motor_control_paramter=50 ,steps_for_one_revolution=520
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% the followings are calculated automaticaaly %%%%%%%%%%%%%%%%%%%%
wheel_diameter=146 %in mm by measruement
step_length_mm=wheel_diameter*pi/steps_for_one_revolution %need to redo again
%step_length_mm=0.917
step_angle_degree=(180/pi)*asin( step_length_mm/(wheel_diameter/2) )
%0.72; %0.72 degrees;
%pause
j=0;
% %for calibration use 
% for i=1:260 
%     j=j+1;    
%     motion{j}='forward'; %f=forward,backward,right,left,
% end

for i=1:20
    j=j+1;
    motion{j}='forward'; %f=forward,backward,right,left,
end
for i=1:40
    j=j+1;
    motion{j}='left'; %f=forward,backward,right,left,
    j=j+1;
    motion{j}='forward'; %f=forward,backward,right,left,
end
for i=1:20
    j=j+1;
    motion{j}='forward'; %f=forward,backward,right,left,
end
for i=1:80
    j=j+1;
    motion{j}='right'; %f=forward,backward,right,left,
    j=j+1;
    motion{j}='forward'; %f=forward,backward,right,left,
end

N_steps=length(motion)
% simulation SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
%simulation
for i=1:N_steps
    switch motion{i}
        case 'forward' 
            motion_a(i)= 0;
            motion_z(i)= step_length_mm;
        case 'backward' 
            motion_a(i)= 0;
            motion_z(i)= -step_length_mm;
        case 'right' 
            motion_a(i)= step_angle_degree*pi/180; %0.72*pi/180;
            motion_z(i)= 0;
        case 'left' 
            motion_a(i)= -step_angle_degree*pi/180;
            motion_z(i)= 0;
    end
end
%11111111111111111111111111111111111111111111111111111111111111
figure(1)
clf
hold on
max_d=100; %in mm
plot(-max_d,0,'k.');% make sure xy appears in the same magnitude
plot(max_d,max_d,'k.');% make sure xy appears in the same magnitude
acc_motion_a(1)=0;
acc_motion_x(1)=0;
acc_motion_z(1)=0;
for i=1:N_steps-1
    acc_motion_a(i+1)=motion_a(i)+acc_motion_a(i);
    acc_motion_z(i+1)= acc_motion_z(i)  + motion_z(i)*cos(acc_motion_a(i));
    acc_motion_x(i+1)= acc_motion_x(i) + motion_z(i)*sin(acc_motion_a(i));
    %    plot(acc_motion_x,acc_motion_z,'rs','MarkerSize','20')
    plot(acc_motion_x,acc_motion_z,'rs')
end
ylabel('z-axis in mm')
xlabel('negative x-axis in mm')
title('robot motion simulation')

%222222222222222222222222222222222222222222222222222222222222
figure(2)
clf
hold on
subplot(3,1,1);
hold on
for i=1:N_steps-1
    plot(i,acc_motion_x(i),'rx')
end
ylabel('motion-x mm')

subplot(3,1,2);
hold on
for i=1:N_steps-1
    plot(i,acc_motion_z(i),'gx')
end
ylabel('motion-z mm')

subplot(3,1,3);
hold on
for i=1:N_steps-1
    %    plot(i,acc_motion_a(i)*180/pi,'bx-')
    plot(i,acc_motion_a(i)*180/pi,'bx')
end
ylabel('motion-a degree')
title('motion parameter plots')

disp('save motion_dat')
save motion_dat
%save ('motion_dat','motion','acc_motion_x','acc_motion_z','acc_motion_a');
%save ('motion_dat','motion');
N_steps
disp('% start robot RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR%%');
disp('%   press any key to start robot                   %');
disp('% start robot RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR%%');
disp('? > ')
pause

%R start robot RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR


if camera_mode==1
    cardnum=vcapg2; % you will get available video capture devices number usually 1
    close all;figure(1);set(1,'doublebuffer','on');
    'paused, press any ket to get pics'
    pause
    
    % capture mode
    mkdir('C:\\0vision\\0test_images','cam101');
    mkdir('C:\\0vision\\0test_images','cam201');
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
photos_j=0
for i=0:steps_per_photo:N_steps-1
    photos_j=photos_j+1;
    i
    %    	printf("ParallelPortControl <forward/backward/left/right> <value>\n\n");
    %    dos_return=dos('ParallelPortControl forward 100');
    %        dos_return=dos('ParallelPortControl left 50'); % use the correct step size, 0.72 degress
    if robot_run_mode==1
        mot=motion{i+1};
        command_string1=sprintf('ParallelPortControl %s %d',mot, motor_control_paramter);
        dos_return=dos(command_string1);
    end
    if camera_mode==1
        pause(1) %pause to wait for the robot to become stable
        [aa,bb]=vcapg2;% grabbing camera image.
        
        imwrite(aa,sprintf('C:\\0vision\\0test_images\\cam101\\cam101_%03d.jpg',i),'jpg');
        %disp('xlol%d.jpg saved');
        imwrite(bb,sprintf('C:\\0vision\\0test_images\\cam201\\cam201_%03d.jpg',i),'jpg');
        %disp('ylol%d.jpg saved');
        i
        disp('a pair of pics is saved');
    end
end
photos_j

N_steps
