function R = rpymat2 (angs)
% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw angles.

c = cos(angs(1));
s = sin(angs(1));
%Rx=[1 0 0; 0 c -s; 0 s c];
Rx=[1 0 0; 0 c s; 0 -s c];      %reverse rotation for camera  center
c = cos(angs(2));
s = sin(angs(2));
%Ry=[c 0 s; 0 1 0; -s 0 c];
Ry=[c 0 -s; 0 1 0; s 0 c];
c = cos(angs(3));
s = sin(angs(3));
%Rz=[c -s 0; s c 0; 0 0 1];
Rz=[c s 0; -s c 0; 0 0 1];

R=Rz*Ry*Rx;

% cosA = cos (angs(3));
% sinA = sin (angs(3));
% cosB = cos (angs(2));
% sinB = sin (angs(2));
% cosC = cos (angs(1));
% sinC = sin (angs(1));
% 
% cosAsinB = cosA .* sinB;
% sinAsinB = sinA .* sinB;
% 
% R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
%       sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
%         -sinB            cosB.*sinC                 cosB.*cosC         ];
return

